<template>
  <div class="container mx-auto mt-4 max-w-screen-sm">
    <Header />
    <div class="mt-4">
      <AddTask @add-task="handleAddTask" />
    </div>
    <div class="flex flex-col mx-auto w-[450px] mt-4"> 
      <h2>Tasks to-do:</h2>
      <TaskList class="mt-4" :tasks="unfinishedTasks" @complete-task="handleTaskCompleted" @delete-task="handleTaskRemoved" />
    </div>
    <div class="flex flex-col mx-auto mt-4 w-[450px]"> 
      <h2>Tasks done:</h2>
      <TaskList class="mt-4" :tasks="finishedTasks"/>
    </div>
  </div>
</template>

<script setup lang="ts">
import Header from "./components/Header.vue";
import AddTask from "./components/AddTask.vue";
import TaskList from "./components/TaskList.vue";
import type Task from "./model/Task";
import { computed, ref, PropType, defineProps, onMounted } from "vue";
import {toast} from "vue3-toastify"

const props = defineProps({
  tasks: {
    required: true,
    type: Array as PropType<Task[]>,
  },
});

const tasks = ref<Task[]>([]);

onMounted(() => {
  if (localStorage.getItem('tasks') !== null){
    const savedTasks = JSON.parse(localStorage.getItem('tasks'));

    if (savedTasks) {
      tasks.value = savedTasks
    }

  }
})

const handleAddTask = (taskName: string) => {

  if (taskName === ''){
    toast.error("Yo need to fill the name")
    return 
  }
  
  const task:Task = {
    name: taskName,
    active: true,
    id: generateUniqueId()
  }
  
  tasks.value.push(task);

  saveTasksToLocalStorage();

  toast.success("Task has been added")
  return task
}

const handleTaskCompleted = (taskId: string) => {
  const index = tasks.value.findIndex(task => task.id === taskId)
  let task = tasks.value.find(task => task.id === taskId)
  if (task) {
    task.active = false
    tasks.value[index] = task
    toast.success("Task has been completed")

    saveTasksToLocalStorage();
  }  
}

const handleTaskRemoved = (taskId: string) => {
  tasks.value = tasks.value.filter((task: Task) => {
    return task.id !== taskId
  })
  toast.success("Task has been removed")

  saveTasksToLocalStorage()
}

const finishedTasks = computed(() => {
  return tasks.value.filter((task) => task.active === false);
});

const unfinishedTasks = computed(() => {
  return tasks.value.filter((task) => task.active === true);
});

const generateUniqueId = () => {
  const rand = Math.floor(Math.random() * 1000000);
  return rand.toString()
};

const saveTasksToLocalStorage = () => {
  localStorage.setItem('tasks', JSON.stringify(tasks.value));
}

</script>
